MVTest/Models/Matrix.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace MVTest.Models
{
    public class Matrix
    {
        public int Rows { get; set; }
        public int Columns { get; set; }
        public List<int []> Values { get; set; }

        
        public Matrix()
        {
            
        }

        public Matrix(int Rows,int Columns)
        {
            this.Rows = Rows;
            this.Columns = Columns;
            this.Values = new List<int[]>();

            for(int i = 0; i < Columns; i++)
            {
                int[] zero_arr = new int[Rows];
                for(int j = 0; j < Rows; j++)
                {
                    zero_arr[j] = 0;
                }
                this.Values.Add(zero_arr);
            }
        }
    }
}

MVTest/Models/ViewModel/MatrixViewModel.cs
using MVTest.Helpers;
using System.Web;

namespace MVTest.Models.ViewModel
{
    public class MatrixViewModel
    {
        [FileValidator(ErrorMessage = "Please upload the .csv file")]
        public HttpPostedFileBase FileObj { get; set; }

        public Matrix MatrixView { get; set; }

        public MatrixViewModel()
        {
            this.MatrixView = new Matrix(5, 5);
        }
    }
}

MVTest/Controllers/MatrixController.cs
using MVTest.Models;
using MVTest.Models.ViewModel;
using MVTest.Services.Interfaces;
using System.IO;
using System.Web;
using System.Web.Mvc;

namespace MVTest.Controllers
{
    public class MatrixController : Controller
    {
        private readonly IMatrixService service;

        public MatrixController(IMatrixService service)
        {
            this.service = service;
        }

        [HttpGet]
        public ActionResult Index()
        {
            return View(new MatrixViewModel());
        }

        [HttpPost]
        public ActionResult ExportMatrix(MatrixViewModel model)
        {
            var result = service.ExportMatrixCvs(Server.MapPath("~/App_Data"), model);
            if (result.Succeed)
            {                
                return File((string)result.ReturnedValue, "application/vnd.ms-excel", "matrix.csv");
            }

            return View("Index",model);
        }

        [HttpPost]
        public ActionResult LoadMatrix(MatrixViewModel model)
        {
            if (ModelState.IsValid)
            {
                var result = service.LoadMatrixCvs(model);
                if (result.Succeed)
                    return View("Index", result.ReturnedValue);
            }            
            
            return View("Index", model);
        }

        [HttpPost]
        public ActionResult RandomMatrix()
        {
            var result = service.RandomMatrix();
            if (result.Succeed)
            {
                return View("Index", result.ReturnedValue);
            }

            return View("Index", new MatrixViewModel());
        }

        [HttpPost]
        public ActionResult TransformMatrix(MatrixViewModel model)
        {
            var result = service.TransformMatrix(model);
            if (result.Succeed)
            {
                ModelState.Clear();
                return View("Index",result.ReturnedValue);
            }

            return View("Index",new MatrixViewModel());
        }
    }
}

MVTest/Views/Matrix/Index.cshtml
@using MVTest.Models
@using MVTest.Models.ViewModel
@model MatrixViewModel
@{
    Layout = "~/Views/Shared/_LayoutMetronik.cshtml";
}

<div class=" m-heading-1 border-green m-bordered">
    <div class="container">
        @using (Html.BeginForm("LoadMatrix", "Matrix", FormMethod.Post, new { enctype = "multipart/form-data" }))
        {
            <div class="row">
                <div class="col-lg-4">
                    @Html.ValidationMessageFor(m => m.FileObj, "", new { @class = "text-danger" })
                    <input class="btn green btn-outline" type="file" name="@Html.NameFor(m=>m.FileObj)" id="@Html.IdFor(m=>m.FileObj)" /><br><br>
                </div>
                <div class="col-lg-4">
                    <input class="btn green-sharp btn-outline  btn-block sbold uppercase" type="submit" value="Upload matrix" />
                </div>
            </div>


        }
    </div>

    <div class="container">
        <div class="row">
            <div class="col-lg-4">
                @using (Html.BeginForm("TransformMatrix", "Matrix", FormMethod.Post))
                {
                    @Html.HiddenFor(m => m.MatrixView.Columns)
                    @Html.HiddenFor(m => m.MatrixView.Rows)
                    for (int i = 0; i < Model.MatrixView.Columns; i++)
                    {
                        for (int j = 0; j < Model.MatrixView.Rows; j++)
                        {
                            @Html.HiddenFor(m => m.MatrixView.Values[i][j])
                        }
                    }

                    <input class="btn green btn-outline" type="submit" value="Transform matrix" />
                }
            </div>
            <div class="col-lg-4">
                @using (Html.BeginForm("ExportMatrix", "Matrix", FormMethod.Post))
                {
                    @Html.HiddenFor(m => m.MatrixView.Columns)
                    @Html.HiddenFor(m => m.MatrixView.Rows)
                    for (int i = 0; i < Model.MatrixView.Columns; i++)
                    {
                        for (int j = 0; j < Model.MatrixView.Rows; j++)
                        {
                            @Html.HiddenFor(m => m.MatrixView.Values[i][j])
                        }
                    }

                    <input class="btn green btn-outline" type="submit" value="Export matrix" />
                }
            </div>
            <div class="col-lg-4">
                @using (Html.BeginForm("RandomMatrix", "Matrix", FormMethod.Post))
                {
                    <input class="btn green btn-outline" type="submit" value="Generate matrix" />
                }
            </div>
        </div>
    </div>
</div>
<div class="portlet light bordered">
    <div class="portlet-title">
        <div class="caption">
            <i class="fa fa-arrows-h font-green"></i>
            <span class="caption-subject font-green bold uppercase">Rows: @Model.MatrixView.Rows</span>
        </div>
        <div class="caption" style="padding-left:20px">
            <i class="fa fa-arrows-v font-green"></i>
            <span class="caption-subject font-green bold uppercase">Columns: @Model.MatrixView.Columns</span>
        </div>
        <div class="portlet-body">
            <div class="table-scrollable">
                @ShowMatrix(Model.MatrixView)
            </div>
        </div>
    </div>
</div>

@helper ShowMatrix(Matrix matrix)
{    
    <table class="table table-hover">
        <tbody>
            @for (int i = 0; i < matrix.Columns; i++)
            {
                <tr>
                    @for (int j = 0; j < matrix.Rows; j++)
                    {
                        <td style="padding-right:10px;">
                            @Html.DisplayFor(m => m.MatrixView.Values[i][j])
                        </td>
                    }
                </tr>
            }
        </tbody>
    </table>
}

MVTest/Views/Shared/_LayoutMetronik.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>Qwerty</title>
    @Scripts.Render("~/bundles/jquery")
    <link href="http://fonts.googleapis.com/css?family=Open+Sans:400,300,600,700&subset=all" rel="stylesheet" type="text/css" />
    @Styles.Render("~/bundles/jquery-ui/css")
    @Styles.Render("~/Assets/metronik/css")
    @Styles.Render("~/Assets/custom/css")
</head>

<body class="page-container-bg-solid page-header-fixed page-sidebar-closed-hide-logo">
    <div class="page-header navbar navbar-fixed-top">
        <div class="page-header-inner ">
            <div class="page-logo">
                <a href="">
                    <img style="max-height:150px;max-width:150px;" src="~/Assets/logo.png" alt="logo" class="logo-default" />
                </a>
                <div class="menu-toggler sidebar-toggler"></div>                
            </div>
            <a href="javascript:;" class="menu-toggler responsive-toggler" data-toggle="collapse" data-target=".navbar-collapse"> </a>
            <div class="page-top">                
                <div class="top-menu">
                    <ul class="nav navbar-nav navbar-right">
                        
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="clearfix"></div>
    <div class="page-container">
        <div class="page-sidebar-wrapper">
            <div class="page-sidebar navbar-collapse collapse">
                
            </div>
        </div>
        <div class="page-content-wrapper">
            <div class="page-content">
                <ul class="page-breadcrumb breadcrumb">
                    
                </ul>
                <div class="body-content">
                    @RenderBody()
                </div>
            </div>
        </div>
    </div>
    <div class="page-footer">
        <div class="page-footer-inner">           
        </div>
        <div class="scroll-to-top">
            <i class="icon-arrow-up"></i>
        </div>
    </div>    
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/ajax")
    @Scripts.Render("~/bundles/bootstrap")
    @Scripts.Render("~/Assets/metronik/js")
    @Scripts.Render("~/Assets/custom/js")
    @RenderSection("scripts", required: false)    
</body>
</html>